const express = require('express');
const multer = require('multer');
const csv = require('csv-parser');
const mysql = require('mysql2/promise');
const fs = require('fs');

const app = express();
const port = 3000;

const storage = multer.memoryStorage(); // Store the uploaded file in memory
const upload = multer({ storage: storage });

const dbConfig = {
  host: 'localhost',
  user: 'your_username',
  password: 'your_password',
  database: 'mydb',
};

app.use(express.json());

// Handle file upload
app.post('/upload', upload.single('csv'), async (req, res) => {
  try {
    if (!req.file) {
      return res.status(400).json({ message: 'No file uploaded' });
    }

    const fileBuffer = req.file.buffer.toString();
    const data = csv.parse(fileBuffer);

    const connection = await mysql.createConnection(dbConfig);
    for (const row of data) {
      const { email, password } = row;
      await connection.execute('INSERT INTO users (email, password) VALUES (?, ?)', [email, password]);
    }

    connection.end();
    return res.status(200).json({ message: 'Data inserted successfully' });
  } catch (error) {
    console.error(error);
    return res.status(500).json({ message: 'Internal server error' });
  }
});

app.listen(port, () => {
  console.log(`Server is running on port ${port}`);
});