const express = require('express');
const mysql = require('mysql');
const feedback_form = express();
// Middleware for parsing JSON
feedback_form.use(express.json());
//DB configure-connection
const connection = require('../config');


//GET from all users 

feedback_form.get('/get', (req, res) => {
    const query = 'SELECT * FROM feedback_form';
  
    connection.query(query, (err, results) => {
      if (err) {
        console.error('Error executing MySQL query: ' + err.stack);
        res.status(500).json({ error: 'Failed to retrieve users' });
        return;
      }
  
      if (results.length === 0) {
        res.status(404).json({ error: 'No users found' });
      } else {
        res.json(results);
      }
    });
  });

  // GET by Id method
feedback_form.get('/get/:id', (req, res) => {
    const userId = req.params.id;
    const query = 'SELECT * FROM feedback_form WHERE id = ?';
  
    connection.query(query, [userId], (err, results) => {
      if (err) {
        console.error('Error executing MySQL query: ' + err.stack);
        res.status(500).json({ error: 'Failed to retrieve user' });
        return;
      }
  
      if (results.length === 0) {
        res.status(404).json({ error: 'User not found' });
      } else {
        res.json(results[0]);
      }
    });
  });

// POST method
feedback_form.post('/post', (req, res) => {
    const {
      users_id,
      name,
      mobile_number,
      message
    } = req.body;
  
    const query = 'INSERT INTO feedback_form (users_id, name, mobile_number, message, created_at, updated_at) VALUES (?, ?, ?, ?, NOW(), NOW())';
  
    const parameters = [
      users_id,
      name,
      mobile_number,
      message
       // Use the donar_registered_date value if provided, or use null if it's not provided
    ];
  
    connection.query(query, parameters, (err, results) => {
      if (err) {
        console.error('Error executing MySQL query: ' + err.stack);
        res.status(500).json({ error: 'Failed to create user' });
        return;
      }
  
  
      res.json({message: 'User created successfully' });
    });
  });


//PUT method
  feedback_form.put('/put/:id', (req, res) => {
    const Id = req.params.id;
    const updatedData = req.body;
  
    const query = 'UPDATE feedback_form SET ? WHERE id = ?';
    connection.query(query, [updatedData, Id], (error, results) => {
      if (error) {
        console.error('Error executing query:', error);
        res.status(500).json({ error: 'Error executing query' });
      } else {
        if (results.affectedRows > 0) {
          res.json({ message: 'Data updated successfully' });
        } else {
          res.status(404).json({ error: 'Book not found' });
        }
      }
    });
  });


  // DELETE method
feedback_form.delete('/delete/:id', (req, res) => {
    const userId = req.params.id;
    const query = 'DELETE FROM feedback_form WHERE id = ?';
    connection.query(query, [userId], (err, results) => {
      if (err) {
        console.error('Error executing MySQL query: ', err);
        res.sendStatus(500);
        return;
      }
  
      if (results.affectedRows === 0) {
        res.sendStatus(404);
        return;
      }
  
      res.sendStatus(200);
    });
  });

module.exports = feedback_form;