const express = require('express');
const login = express();
login.use(express.json());
const jwt = require('jsonwebtoken');
const connection = require('../config');
require('dotenv').config(); 
const fs = require('fs');
const multer = require('multer');
const csv = require('csv-parser');
const mysql = require('mysql');


const storage = multer.memoryStorage();
const upload = multer({ storage: storage });

login.post('/upload-csv', upload.single('csvFile'), (req, res) => {
    if (!req.file) {
      return res.status(400).send('No file uploaded.');
    }
  
    const fileBuffer = req.file.buffer.toString();
    const records = fileBuffer.split('\n');
  
    for (const record of records) {
      // Split the CSV record into columns
      const [coupon_text] = record.split(','); // Assuming the first column is coupon_text
  
      // Check if coupon_text is empty, and if it is, skip this iteration
      if (!coupon_text.trim()) {
        continue;
      }
  
      // Extract other columns from your manual payload data
      const { master_id, is_assigned, assigned_to, assigned_on, coupon_created_at } = req.body;
  
      const sql = 'INSERT INTO login (coupon_text, master_id, is_assigned, assigned_to, assigned_on, coupon_created_at) VALUES (?, ?, ?, ?, ?, ?)';
  
      connection.query(sql, [coupon_text, master_id, is_assigned, assigned_to, assigned_on, coupon_created_at], (err) => {
        if (err) {
          console.error(err);
        }
      });
    }
  
    res.send('CSV data uploaded and inserted into the database.');
  });
  
  

  module.exports = login;