const express = require('express');
const mysql = require('mysql');
const jwt = require('jsonwebtoken');
const user_otpverification = express();
// Middleware for parsing JSON
user_otpverification.use(express.json());
//DB configure-connection
const connection = require('../config');

const accountSid = "AC687a5d704ddf66a2f9b34c92669eca7d";
const authToken = "3e78890ee75c0ea8a53f7bb0ed662987";
const client = require('twilio')(accountSid, authToken);


// Login route
user_otpverification.post('/login', (req, res) => {
  const mobile_number = req.body.mobile_number;
  const otp_code_tocheck = req.body.otp_code;

  connection.query('SELECT * FROM user_otpverification WHERE mobile_number = ? and is_verified= false', [mobile_number], (error, results) => {
    if (error) {
      console.error(error);
      res.sendStatus(500);
    } else {
      if (results.length > 0) {
        // Mobile number exists, get the OTP code and generate a JWT token
        const user = results[0];
        if(otp_code_tocheck == user.otp_code ){
          const token = jwt.sign({ userId: user.id }, 'your_secret_key');
          const getuserdetail = 'SELECT * FROM `users`  where `mobile_number` = "'+mobile_number+'"';

          connection.query("update user_otpverification set is_verified=true where id = "+user.id, (err, dat) => {
            if (err) {
              console.error('Error executing MySQL query: ' + err.stack);
              res.status(500).json({ error: 'Failed to retrieve users' });
              return;
            }

          connection.query(getuserdetail, (err, users) => {
            if (err) {
              console.error('Error executing MySQL query: ' + err.stack);
              res.status(500).json({ error: 'Failed to retrieve users' });
              return;
            }

            res.status(200).json({ token:token , userdata: users});
          });
          });
          
        }else {
          // Mobile number not found in the database
          res.sendStatus(401);
        }
        
      } else {
        // Mobile number not found in the database
        res.sendStatus(401);
      }
    }
  });
});

// GET all users

user_otpverification.get('/all-user', (req, res) => {
  const query = 'SELECT * FROM user_otpverification';

  connection.query(query, (err, results) => {
    if (err) {
      console.error('Error executing MySQL query: ' + err.stack);
      res.status(500).json({ error: 'Failed to retrieve users' });
      return;
    }

    if (results.length === 0) {
      res.status(404).json({ error: 'No users found' });
    } else {
      res.json(results);
    }
  });
});


// GET by ID method
user_otpverification.get('/user/:id', (req, res) => {
  const userId = req.params.id;
  const query = 'SELECT * FROM user_otpverification WHERE id = ?';

  connection.query(query, [userId], (err, results) => {
    if (err) {
      console.error('Error executing MySQL query: ' + err.stack);
      res.status(500).json({ error: 'Failed to retrieve user' });
      return;
    }

    if (results.length === 0) {
      res.status(404).json({ error: 'User not found' });
    } else {
      res.json(results[0]);
    }
  });
});
function generateOTP() {
  const min = 100000; // Minimum value for 6-digit OTP (inclusive)
  const max = 999999; // Maximum value for 6-digit OTP (inclusive)
  return Math.floor(Math.random() * (max - min + 1)) + min;
}
// POST method
user_otpverification.post('/add-user', (req, res) => {
  const { mobile_number } = req.body;
  let otp_code = generateOTP().toString(); // Generate a random 6-digit OTP
  let date = new Date();
  let otp_code_expiry = new Date(date.getTime() + 2*60000);
  let is_verified = false;
  connection.query('SELECT * FROM user_otpverification WHERE mobile_number = ? and is_verified= false', [mobile_number], (error, results) => {
    if (error) {
      console.error(error);
      res.sendStatus(500);
    } else {
      client.messages
        .create({
          body: 'Your OTP for login to Blood App is '+otp_code,
          messagingServiceSid: 'MG00c664440e4a8e859d571ccdfbe75f26',
          to: '+91'+mobile_number
        })
        .then(message => console.log(message.sid));
      if (results.length > 0) {
        
        const query = 'UPDATE `user_otpverification` SET `otp_code` = ?, `otp_code_expiry` = ? WHERE `user_otpverification`.`mobile_number` = ? and is_verified = 0;';

        connection.query(query, [otp_code, otp_code_expiry,mobile_number,  is_verified], (err, results) => {
          if (err) {
            console.error('Error executing MySQL query: ' + err.stack);
            res.status(500).json({ error: 'Failed to create user' });
            return;
          }

          res.json({ message: 'OTP Sent Successfully' });
        });
      } else {
        const query = 'INSERT INTO user_otpverification (mobile_number, otp_code, otp_code_expiry, is_verified, created_at, updated_at) VALUES (?, ?, ?, ?, NOW(), NOW())';

        connection.query(query, [mobile_number, otp_code, otp_code_expiry, is_verified], (err, results) => {
          if (err) {
            console.error('Error executing MySQL query: ' + err.stack);
            res.status(500).json({ error: 'Failed to create user' });
            return;
          }

          res.json({ message: 'OTP Sent Successfully' });
        });
      }
    }
  });
  
});

// PUT method
user_otpverification.put('/edit-user/:id', (req, res) => {
  const userId = req.params.id;
  const { mobile_number, otp_code, otp_code_expiry, is_verified } = req.body;
  const query = 'UPDATE user_otpverification SET mobile_number = ?, otp_code = ?, otp_code_expiry = ?, is_verified = ?, updated_at = NOW() WHERE id = ?';

  connection.query(query, [mobile_number, otp_code, otp_code_expiry, is_verified, userId], (err, results) => {
    if (err) {
      console.error('Error executing MySQL query: ' + err.stack);
      res.status(500).json({ error: 'Failed to update user' });
      return;
    }

    if (results.affectedRows === 0) {
      res.status(404).json({ error: 'User not found' });
    } else {
      res.json({ message: 'User updated successfully' });
    }
  });
});

// DELETE method
user_otpverification.delete('/delete-user/:id', (req, res) => {
  const userId = req.params.id;
  const query = 'DELETE FROM user_otpverification WHERE id = ?';

  connection.query(query, [userId], (err, results) => {
    if (err) {
      console.error('Error executing MySQL query: ' + err.stack);
      res.status(500).json({ error: 'Failed to delete user' });
      return;
    }

    if (results.affectedRows === 0) {
      res.status(404).json({ error: 'User not found' });
    } else {
      res.json({ message: 'User deleted successfully' });
    }
  });
});

module.exports = user_otpverification;
