// index.js
const express = require('express');
const app = express();
require('dotenv').config();
const cors = require('cors');
const port = 4000;
const connection = require('./config');
const user_otpverification = require('./db_table/user_otpverification');
const users = require('./db_table/users');
const users_donar_profile = require('./db_table/users_donar_profile');
const blood_request = require('./db_table/blood_request');
const blood_request_responses = require('./db_table/blood_request_responses');
const admin_users = require('./db_table/admin_users');
const coupon_master = require('./db_table/coupon_master');
const coupon_details = require('./db_table/coupon_details');
const claim_details = require('./db_table/claim_details');
const coupon_transactions = require('./db_table/coupon_transactions');
const core_team = require('./db_table/core_team');
const feedback_form = require('./db_table/feedback_form');


const login = require('./db_table/login');
//cors
app.use(cors());

// Connect to MySQL
connection.connect((err) => {
  if (err) {
    console.error('Error connecting to MySQL database:', err);
    return;
  }
  console.log('Connected to MySQL database');
});

// Use the table middleware with a base URL
app.use('/api/user_otpverification', user_otpverification);
app.use('/api/users', users);
app.use('/api/users_donar_profile', users_donar_profile);
app.use('/api/blood_request', blood_request);
app.use('/api/blood_request_responses', blood_request_responses);
app.use('/api/admin_users', admin_users);
//phase-2
app.use('/api/coupon_master', coupon_master);
app.use('/api/coupon_details', coupon_details);
app.use('/api/claim_details', claim_details);
app.use('/api/coupon_transactions', coupon_transactions);
app.use('/api/login', login);
//phase-3
app.use('/api/core_team', core_team);
app.use('/api/feedback_form', feedback_form);

// Start the server
app.listen(port, () => {
  console.log(`Server listening on port ${port}`);
});
